#include "process.h"
#include "test.h"
#include "../../../../process.h"
#include "../../../../system.h"
#include "../../../../unittest.h"
#include "../../../../interfaces/hw_stop_interface/process.h"
#include "../hw_stop_process/process.h"

static void tick();

struct HWStopController hw_stop_controller = {
    .tick = tick
};

static void (*current_state)();

static void ready();
static void stop();

void init_hw_stop_controller(){
    printf("Initialization Hw Stop Controller...\t\t");
    set_process(HW_STOP_CONTROLLER, &hw_stop_controller);
	SET_UNIT_TEST(HW_STOP_CONTROLLER, hw_stop_controller_unit_test);
	add_tick_listener(hw_stop_controller.tick);
	printf("\033[92m[OK]\033[0m\n");
	
	current_state = ready;
}

static void tick()
{
    current_state();
}

static void ready()
{
    struct HWStopInterface *interface = get_process(HW_STOP_INTERFACE);
    struct HWStopProcess *process = get_process(HW_STOP_PROCESS);
    
    if ( interface->hw_stop() ) {
        process->trigger();
        current_state = stop;
    }
}

static void stop() {
    current_state = ready;
}
